
(function($) {

Drupal.bisnode = Drupal.bisnode || {};


Drupal.bisnode.getMappingFieldResult = function(mapping, result) {
  if (result && typeof result[mapping] == 'string') {
    return result[mapping];
  }

  return '';
}

Drupal.behaviors.bisnodeWebapiJs = {
  attach: function(context, settings) {
    $.each(settings.bisnode, function(webform_id) {
      var bisnode_setting = settings.bisnode[webform_id];

      $('.webform-submission-' + webform_id.replace(/_/g, '-') + '-form', context).once('bisnode').each(function() {
        var $form = this;
        var timeObject = null;
        var searchField = bisnode_setting.search_field;
        var loading = $('<div class="loading-bisnode">' + bisnode_setting.loading_text + '</div>');

        $('.bisnode-search-field--' + searchField + ' input, input.bisnode-search-field--' + searchField, $form).on('change keyup', function(event) {
          loading.remove();
          var xhrAjax = null
          var timeOut = 1000;
          var $this = $(this);
          var search = $this.val();

          clearTimeout(timeObject);

          if (search == '') {
            return;
          }

          if (event.type == 'change') {
            timeOut = 100;
          }

          timeObject = setTimeout(function() {
            // Abort a old ajax in process.
            if (xhrAjax) {
              xhrAjax.abort();
            }

            $this.after(loading);

            xhrAjax = $.ajax({
              url: settings.path.baseUrl + 'bisnode/search-directory',
              method: 'POST',
              data: {
                string: search
              },
              success: function (data) {
                xhrAjax = null;

                var e = document.createEvent('CustomEvent');
                e.initCustomEvent('bisnode-response-received', true, false, data);
                window.dispatchEvent(e);

                // Only if we have a one result.
                if (data.results.length == 1) {
                  var result = data.results[0];
                  for (var mapping in bisnode_setting.mapping_fields) {
                    if (bisnode_setting.mapping_fields[mapping] == 'none') {
                      continue;
                    }

                    var value = Drupal.bisnode.getMappingFieldResult(bisnode_setting.mapping_fields[mapping], result);
                    if (value) {
                      $('.bisnode-mapped-field--' + mapping + ' input, input.bisnode-mapped-field--' + mapping, $form).val(value);
                    }
                  }
                }

                loading.remove();
              }
            });
          }, timeOut);
        });
      });
    });
  }
}

})(jQuery);